import asyncdispatch, jester, json

import ./configuration, ./core

settings:
  port = Port(8180)


proc start*(givenCfg: StrawBossConfig): void =

  routes:
    get "/api/ping":
      resp $(%*"pong"), "application/json"

    get "/api/projects":
      resp $(%*[]), "application/json"

    post "/api/project/@projectName/@stepName/run/@buildRef?":
      let req = RunRequest(
        projectName: @"projectName",
        stepName: @"stepName",
        buildRef: if @"buildRef" != "": @"buildRef" else: nil,
        async: true,
        forceRebuild: false)  # TODO support this with optional query params

#      try:
#        let runSummary = core.runStep(givenCfg, req)
#      except:
#        discard ""
#        # TODO


  runForever()
